/**
 * Copyright 2005 Jdon.com
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at

 http://www.apache.org/licenses/LICENSE-2.0

 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package com.framwork;

import org.picocontainer.MutablePicoContainer;
import org.picocontainer.defaults.DefaultPicoContainer;

import java.util.List;


/**
 * 注册拦截器；
 * <p>Copyright: Jdon.com Copyright (c) 2003</p>
 * <p></p>
 * @author banq
 * @version 1.0
 */
public class AopInterceptorRegistry implements com.framwork.container.ContainerRegistry {

    //子容器的名称

    public final static String AOP_NAME = "child";

    private com.framwork.container.ContainerWrapper containerWrapper;

    public com.framwork.container.ContainerWrapper getContainerWrapper() {
        return containerWrapper;
    }

    public AopInterceptorRegistry(com.framwork.container.ContainerWrapper containerWrapper) {
        this.containerWrapper = containerWrapper;
    }

    /**
     * 向总pico注册子pico
     * 子pico中是所有的拦截器；目前只有一个cacheInterceptor
     *
     * @param  parentContainer MutablePicoContainer
     */
    public void register() {
        containerWrapper.registerChild(AOP_NAME);
        MutablePicoContainer child = (MutablePicoContainer) containerWrapper.lookup(AOP_NAME);
        //注册拦截器 需要在ModelManager之后
        child.registerComponentImplementation(com.framwork.aop.interceptor.CacheInterceptor.class);

    }


}
