package com.framwork;

import com.framwork.cache.CacheFactory;
import com.framwork.container.ContainerRegistry;
import com.framwork.container.ContainerWrapper;

public class CacheFactoryRegistry implements ContainerRegistry {
  public final static String CF_NAME = "CacheFactory";

  private ContainerWrapper containerWrapper;
  public ContainerWrapper getContainerWrapper() {
    return containerWrapper;
  }

  public CacheFactoryRegistry(ContainerWrapper containerWrapper) {
    this.containerWrapper = containerWrapper;
  }

  public void register() {
    CacheFactory cacheFactory = new CacheFactory();
    containerWrapper.register(CF_NAME, cacheFactory);
  }

}
