package com.framwork;

import org.picocontainer.Parameter;
import org.picocontainer.MutablePicoContainer;
import org.picocontainer.defaults.ComponentParameter;

import java.util.Collection;
import java.util.List;

import com.framwork.aop.AopClient;
import com.framwork.aop.joinpoint.JoinpointFactory;
import com.framwork.container.ContainerRegistry;
import com.framwork.container.ContainerWrapper;
import com.framwork.web.KeyConstants;

/**
 * ServiceFactory
 *
 * PicocontainerService
 *
 * <p>Copyright: Jdon.com Copyright (c) 2003</p>
 * <p></p>
 * @author banq
 * @version 1.0
 */
public class ServiceRegistry implements ContainerRegistry, KeyConstants {

  private ContainerWrapper containerWrapper;

    private Collection configList;

  public ContainerWrapper getContainerWrapper() {
    return containerWrapper;
  }

  public ServiceRegistry(ContainerWrapper containerWrapper, Collection configList) {

    this.containerWrapper = containerWrapper;
    this.configList = configList;
  }

  /**
   * Ӻǰעᡣ
   * 1. նtarget
   * 2. AOP
   * 3. BusinessProxy
   * 4. VisitorCache
   * 5. ͻ˵ServiceAdapter
   */
  public void register() {

    registerTatgetService();

    registerAOPService();

    registerBusinessProxyService();

    //עͻ˵õService

    /*
    containerWrapper.register(SERVICE_NAME, DefaultServiceAdapter.class);

    //XMLEJB serviceá
    containerWrapper.register("configList", configList);
    containerWrapper.register(EJBDL_NAME, EJBTargetMetaDefXmlLoader.class,
                              new Parameter[] {
      new ComponentParameter("configList")
    });

    */
    }


  public void registerTatgetService() {
    /*
    containerWrapper.register(TARGET_SERVICE, EJBTargetService.class);
    containerWrapper.register(METHOD_INVOKER, EJBMethodInvoker.class);
    */
  }

  public void registerAOPService() {


    //
    MutablePicoContainer child = (MutablePicoContainer) containerWrapper.lookup( AopInterceptorRegistry.AOP_NAME);
    List inerceptors = child.getComponentInstances();
    containerWrapper.register("inerceptors", inerceptors);
    containerWrapper.register("JoinpointFactory",
            JoinpointFactory.class,new Parameter[] { new ComponentParameter("inerceptors"), new ComponentParameter(METHOD_INVOKER)
    });

    containerWrapper.register(AOP_CLIENT, AopClient.class);

  }

  public void registerBusinessProxyService() {
     /*
     //VisitableFactory
    containerWrapper.register(VISITABLEFACTORY_NAME, VisitableFactory.class);
    //עVisitorFactory
    containerWrapper.register(VISIORFACTORY_NAME, VisitorFactory.class);
      */
  }

}
