package com.framwork.dao;

import com.framwork.dao.Persistent;

import java.lang.reflect.Method;

/**
 * AOPʵ
 * ļƣPersistentAbstract.java
 * @author BILL
 * @version $Revision: 1.0 $ $Date: 2005-01-26 11:31 $
 */
public abstract class PersistentAbstract implements Persistent, java.lang.reflect.InvocationHandler {

    /*
    *  storeProxy Proxyinstance,store Midinstance
   */
    protected Store store = null;
    protected Store storeProxy = null;

    public PersistentAbstract() {

    }

    /*
    * Pojo Master ID
   */
    public String getPKName() {
        return "id";
    }

    /*
     * Pojo<==>tableName
    */
    public String getTableName() {
        return null;
    }


    String[] changeColoum = null;

    public void setChangeColoum(String[] changeColoum) {
        this.changeColoum = changeColoum;
    }


    public void setChangeColoum(javax.servlet.http.HttpServletRequest request) {
        String changeColoum = "";
        java.util.Enumeration enum = request.getParameterNames();
        while (enum.hasMoreElements()) {
            if (!changeColoum.equals("")) changeColoum += "%";
            changeColoum += enum.nextElement();
        }

        this.changeColoum = changeColoum.split("%");
    }


    /*
    * Modify coloum
   */
    public String[] getChangeColoum() {
        return changeColoum;
    }


    public long getSize() {
        return -1L;
    }


    public boolean cacheble = true;

    public boolean isForbidNull() {
        return true;
    }

    public boolean isCacheble() {
        return cacheble;
    }


    public Persistent add() {
        try {
            return store.create(this);
        } catch (StoreException e) {
            e.printStackTrace();
            return null;
        }
    }

    public Persistent update() {
        try {
            return store.store(this);
        } catch (StoreException e) {
            e.printStackTrace();
            return null;
        }
    }


    public Object load(String id) {
        try {
            return store.load(id, this);
        } catch (StoreException e) {
            e.printStackTrace();
            return null;
        }
    }

    public boolean delete() {
        try {
            return store.remove(this);
        } catch (StoreException e) {
            e.printStackTrace();
            return false;
        }
    }

    public boolean delete(String[] id) {
        try {
            return store.remove(this, id);
        } catch (StoreException e) {
            e.printStackTrace();
            return false;
        }
    }


    public boolean delete(String where) {
        try {
            store.addWhere(where);
            return store.remove(this);

        } catch (StoreException e) {
            e.printStackTrace();
            return false;
        }
    }


    /**
     *@see StoreImp implemtation Store ,
     * Storeӿ
     */
    public void initProxyInstance() {
        storeProxy = store;
        Class cls = storeProxy.getClass();
        //,
        store = (Store) java.lang.reflect.Proxy.newProxyInstance(cls.getClassLoader(), cls.getInterfaces(), this);
    }


    /**
     *չӦ,Ĭϴ,ӦдЩ
     * Storeӿڵз
     * Create advies before joinpoint
     */
    public void beforeMethod(Object proxy, Method method, Object[] args) {
        System.out.println("Before calling " + method.getName());
    }

    /**
     *չӦ,Ĭϴ,ӦдЩ
     * Storeӿڵз
     * Create advies after joinpoint
     */
    public void afterMethod(Object proxy, Method method, Object[] args) {
        System.out.println("After calling " + method.getName());
    }


    public final Object invoke(Object proxy, Method method, Object[] args) throws Throwable {
        beforeMethod(proxy, method, args);
        Object o = method.invoke(storeProxy, args);
        afterMethod(proxy, method, args);
        return o;
    }


    public void beginTransaction() throws StoreException {
        store.beginTransaction();
    }


    public void commit() throws StoreException {
        store.commit();
    }

    public void rollback() throws StoreException {
        store.rollback();
    }

    public void clearParameters() {
        store.clearParameters();
    }


    public Store addWhere(String str) {
        return store.addWhere(str);
    }


    public Store addASC(String str) {
        return store.addASC(str);
    }

    public Store addCPKey(String str) {
        return store.addCPKey(str);
    }

    public Store addDESC(String str) {
        return store.addDESC(str);
    }

    public void close() throws StoreException {
        store.close();
        store = null;
    }



    public java.util.Iterator executeQuery() {
        try {
            return store.executeQuery(this);
        } catch (StoreException e) {
            e.printStackTrace();
            return null;
        }

    }


    public java.util.Iterator executeQuery(int pageIndex, int pageSize) {
        try {
            store.setPageCtr(pageIndex, pageSize);
            return store.executeQuery(this);
        } catch (StoreException e) {
            e.printStackTrace();
            return null;
        }

    }

    /**
    public void setPageCtr(int pageIndex, int pageSize) {

        store.setPageCtr(pageIndex, pageSize);
    }
    */

    public java.util.Iterator executeQuery(boolean inc) {
        try {
            return store.executeQuery(this, inc);
        } catch (StoreException e) {
            e.printStackTrace();
            return null;
        }

    }


    public int getCount() {
        return store.getCount();
    }

    public int getIntPageCount() {
        return store.getIntPageCount();
    }

    public int getIntCurPage() {
        return store.getIntCurPage();
    }


}
