package com.framwork.dao;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import com.framwork.util.BeanUtils;
import com.framwork.page.ObjectFactory;
import com.framwork.page.StringList;
import com.framwork.CacheNames;

import java.lang.reflect.InvocationTargetException;

import java.util.HashMap;
import java.util.Iterator;

import com.util.CacheFactory;

import java.sql.PreparedStatement;
import java.sql.ResultSetMetaData;
import java.sql.Types;
import java.sql.Statement;
import java.sql.ResultSet;
import java.sql.Connection;


/**
 * ļƣStoreImp.java
 * @author BILL
 * @version $Revision: 1.0 $ $Date: 2004-09-15 11:31 $
 */
public class StoreImp extends StoreAbstract implements Store, ObjectFactory {

    private Connection conn = null;
    private boolean isCommit = true;
    private Persistent persistent = null;
    private Object tmp_id = null;

    private static Log logger = LogFactory.getLog(StoreImp.class);
    private static HashMap tableField = new HashMap();

    private CacheFactory cach = CacheFactory.getInstance(CacheNames.CACHE_STORE);
    private CacheFactory result = CacheFactory.getInstance(CacheNames.CACHE_RESULT);
    private CacheFactory ddl = CacheFactory.getInstance(CacheNames.CACHE_DDLSQL);

    public synchronized static StoreImp newInstance(Connection conn) {
        return new StoreImp(conn);
    }

    private StoreImp(Connection conn) {
        this.conn = conn;

    }


    private String getPKTypeName(Persistent p) {
        String typeName = null;
        try {
            typeName = BeanUtils.getParameterTypes(p, p.getPKName()).getName();
        } catch (Exception e) {
            typeName = "java.lang.String";
        } finally {
            return typeName;
        }
    }

    private Object getCurrMAXValue(Persistent p) {
        java.sql.ResultSet rs = null;
        Object value = null;
        String typeName = getPKTypeName(p);
        try {
            Statement stmt = conn.createStatement();
            rs = stmt.executeQuery("SELECT MAX(" + p.getPKName() + ") FROM " + getDefalutTableName(p));
            if (rs.next()) {
                if (typeName.equals("java.lang.String"))
                    value = rs.getString(1);
                else if (typeName.equals("int"))
                    value = new Integer(rs.getInt(1));
                else if (typeName.equals("long"))
                    value = new Long(rs.getLong(1));
                else if (typeName.equals("java.sql.Timestamp")) {
                    value = rs.getTimestamp(1);
                } else
                    value = rs.getObject(1);
            }
        } catch (Exception e) {
            e.printStackTrace();
        } finally {

            return value;
        }
    }

    private Object getPKValue(Persistent p) throws StoreException {

        if (tmp_id != null) return tmp_id;
        if (p.getPKName() == null || p.getPKName().trim().equals(""))
            throw new StoreException(p.getClass().getName());
        try {
            return tmp_id = BeanUtils.getProperty(p, p.getPKName());
        } catch (Exception e) {
            e.printStackTrace();
            return null;
        }
    }


    public Persistent create(Persistent obj) throws StoreException {
        return insertObject(obj);
    }

    public Persistent store(Persistent obj) throws StoreException {

        if (!isCPKey && getPKValue(obj) == null)
            throw new StoreException(obj.getClass().getName() + " PrimaryKeyValue NullValueException ");

        this.persistent=obj;
        HashMap values = new HashMap();
        HashMap typeNames = new HashMap();

        String tablename = getDefalutTableName(obj);

        String[] changeCol = obj.getChangeColoum();
        String[] coloum = getReadWriteField(tablename);

        if (changeCol != null) {
            String tmp = "";
            for (int j = 0; j < changeCol.length; j++)
                for (int k = 0; k < coloum.length; k++) {
                    if (coloum[k].toUpperCase().startsWith(changeCol[j].toUpperCase() + "@")) {
                        if (!tmp.equals("")) tmp += "%";
                        tmp += coloum[k];
                        //continue;
                    }

                }
            coloum = tmp.split("%");
        }

        if(coloum==null||coloum.length==0||obj.getPKName()==null)
            return null;

        String typeName = null;
        Object value = null;
        for (int j = 0; j < coloum.length; j++) {

            try {
                if(obj.getPKName().equalsIgnoreCase(coloum[j].split("@")[0]))continue;
                typeName = BeanUtils.getParameterTypes(obj, coloum[j].split("@")[0]).getName();

                value = BeanUtils.getProperty(obj, coloum[j].split("@")[0]);
            } catch (NoSuchMethodException e1) {
                typeName = coloum[j].split("@")[1];
                value = null;
                obj = null;
                //logger.debug(obj.getClass().getName() + " " + e1);
            } catch (Exception e2) {
                obj = null;
                logger.debug(e2.getMessage());
                continue;
            }

            if (value != null

            ) {

                if (value instanceof org.apache.struts.upload.FormFile && value.toString().trim().equals(""))
                    continue;


                typeNames.put(coloum[j].split("@")[0], typeName);
                values.put(coloum[j].split("@")[0], value);
            }
        }

        Iterator iterator = values.keySet().iterator();
        StringBuffer strStmt = new StringBuffer("UPDATE "+tablename +" SET ");
        while (iterator.hasNext()) {
            if (strStmt.indexOf("=?") != -1)
                strStmt.append(",");
            strStmt.append(iterator.next()).append("=?");
        }
        if (!isCPKey)
            strStmt.append(" WHERE " + obj.getPKName() + "=?");
        else
            strStmt.append(" ").append(where);


        LoggableStatement preStmt = null;
        try {
            iterator = values.keySet().iterator();
            preStmt = new LoggableStatement(conn, strStmt.toString());
            int j = 0;
            StringBuffer tmp = new StringBuffer();
              Object object=null;
            for (j = 0; iterator.hasNext(); j++) {
                 object = iterator.next();
                typeName = (String) typeNames.get(object);
                value = values.get(object);


                tmp.append(object).append(",");

                if (value == null) {
                    preStmt.setNull(j + 1, sqlTypeFromClassName(typeName));
                } else if (typeName.equals("java.lang.String")) {
                    preStmt.setString(j + 1, (String) value);
                } else if (typeName.equals("java.sql.Date")) {
                    preStmt.setDate(j + 1, (java.sql.Date) value);
                } else if (typeName.equals("java.sql.Timestamp")) {
                    preStmt.setTimestamp(j + 1, (java.sql.Timestamp) value);
                } else if (typeName.equals("java.sql.Time")) {
                    preStmt.setTime(j + 1, (java.sql.Time) value);
                } else if (typeName.equals("java.util.Date")) {

                    value = new java.sql.Timestamp(((java.util.Date) value).getTime());
                    preStmt.setTimestamp(j + 1, (java.sql.Timestamp) value);

                } else if (typeName.equals("int")) {
                    preStmt.setInt(j + 1, ((Integer) value).intValue());
                } else if (typeName.equals("float")) {
                    preStmt.setFloat(j + 1, ((Float) value).floatValue());
                } else if (typeName.equals("long")) {
                    preStmt.setLong(j + 1, ((Long) value).longValue());
                } else if (typeName.equals("short")) {
                    preStmt.setShort(j + 1, ((Short) value).shortValue());
                } else if (typeName.equals("double")) {
                    preStmt.setDouble(j + 1, ((Double) value).doubleValue());
                } else if (typeName.equals("boolean")) {
                    preStmt.setBoolean(j + 1, ((Boolean) value).booleanValue());

                } else if (value instanceof org.apache.struts.upload.FormFile) {
                    org.apache.struts.upload.FormFile f = (org.apache.struts.upload.FormFile) value;
                    if (f.getFileSize() == 0)
                        preStmt.setNull(j + 1, sqlTypeFromClassName(typeName));
                   else {
                        preStmt.setNull(j + 1, sqlTypeFromClassName(typeName));
                    }

                }

                else {
                    preStmt.setObject(j + 1, value);
                }
            }


            if (!isCPKey) {
                //ȡ
                typeName = getPKTypeName(obj);

                if (typeName.equals("int"))
                    preStmt.setInt(j + 1, ((Integer) getPKValue(obj)).intValue());
                else if (typeName.equals("long"))
                    preStmt.setLong(j + 1, ((Long) getPKValue(obj)).longValue());
                else if (typeName.equals("java.lang.String"))
                    preStmt.setString(j + 1, (String) getPKValue(obj));
                else
                    preStmt.setObject(j + 1, getPKValue(obj));
            }

            if (preStmt.executeUpdate() <= 0)
                throw new StoreException("store executeupdate error");
            else{
                obj.logger("\u4fee\u6539\u6210\u529f",preStmt.getQueryString());
            }

            preStmt.close();
            if (obj.isCacheble()){
                cach.remove(getPKValue(obj) + "@" + tablename);
                result.removePatter("@" + tablename);
            }

        } catch (Exception ex) {
            logger.error(ex.toString());
            obj = null;
            throw new StoreException(ex);
        } finally {
            return obj;
        }
    }

    public boolean remove(Persistent p, String pk) throws StoreException {

        try {

            String tableName = getDefalutTableName(p);
            if (pk == null || pk.trim().equals(""))
                return false;

            String sql = "DELETE FROM  " + tableName + pk;

            PreparedStatement preStmt = conn.prepareStatement(sql);
            int rows = preStmt.executeUpdate();
            preStmt.close();

            if (rows > 0 && persistent.isCacheble()) {

                result.removePatter("@" + tableName);
                cach.removePatter("@" + tableName);
                p.logger("\u5220\u9664\u6210\u529f",sql);
            }

            return rows > 0;
        } catch (Exception e) {
            logger.error(e.toString());
            throw new StoreException(e);
        }
    }

    public boolean remove(Persistent p, String id[]) throws StoreException {

        String tableName = getDefalutTableName(p);

        if (id.length == 0)
            return false;

        StringList list = new StringList();
        String key = null;

        /**
         * ȷɾܹɹݣһ,
         */
        for (int k = 0; k < id.length; k++) {
            list.add(id[k]);
            key = id[k] + "@" + tableName;
            if (p.isCacheble()) {
                cach.remove(key);
            }
        }

        if (p.isCacheble()) {
            result.removePatter("@" + tableName);
        }


        boolean isIntOrLong = false;
        String typeName = getPKTypeName(p);

        if (typeName.equals("int") || typeName.equals("long"))
            isIntOrLong = true;
        else if (typeName.equals("java.lang.String"))
            isIntOrLong = false;

        try {
            //ɾݿ
            String sql = "DELETE FROM  " + tableName + "  WHERE " + p.getPKName() + " IN (" + list.toStringSql(isIntOrLong) + ")";

            PreparedStatement preStmt = conn.prepareStatement(sql);
            int rows = preStmt.executeUpdate();
            if(rows>0){
                  p.logger("\u5220\u9664\u6210\u529f",sql);
            }
            preStmt.close();

            return rows == list.size();
        } catch (Exception e) {
            logger.fatal(e.toString());
            throw new StoreException(e);
        }

    }


    public boolean remove(Persistent p) throws StoreException {
        if (!isCPKey)
            return remove(p, new String[]{getPKValue(p).toString()});
        else
            return remove(p, where.toString());
    }

    private String getDefalutTableName(Persistent p) {
        String tableName = p.getTableName();
        if (tableName == null)
            tableName = p.getClass().getName();
        return tableName;
    }


    public void beginTransaction() throws StoreException {
        try {
            conn.setAutoCommit(false);
            isCommit = false;
        } catch (Exception e) {
            throw new StoreException(e);
        }
    }

    public void rollback() throws StoreException {
        try {
            if (!isCommit) {
                conn.rollback();
                conn.setAutoCommit(true);
                isCommit = true;
            }
        } catch (Exception e) {
            throw new StoreException(e);
        }
    }


    public void commit() throws StoreException {
        try {
            if (!isCommit) {
                conn.commit();
                conn.setAutoCommit(true);
                isCommit = true;
            }
        } catch (Exception e) {
            throw new StoreException(e);
        }
    }

    public void close() throws StoreException {
        try {
            commit();
            conn.close();
            conn = null;
        } catch (Exception e) {
            throw new StoreException(e);
        }
    }


    protected static int sqlTypeFromClassName(String className) throws StoreException {
        if (className.equals("java.lang.String")) return Types.VARCHAR;
        if (className.equals("java.lang.Boolean")) return Types.BIT;
        if (className.equals("java.lang.Integer")) return Types.INTEGER;
        if (className.equals("java.math.BigDecimal")) return Types.NUMERIC;
        if (className.equals("java.lang.Long")) return Types.BIGINT;
        if (className.equals("java.lang.Float")) return Types.REAL;
        if (className.equals("java.lang.Double")) return Types.DOUBLE;
        if (className.equals("[B")) return Types.VARBINARY;
        if (className.equals("org.apache.struts.upload.FormFile")) return Types.VARBINARY;
        if (className.equals("java.sql.Date")) return Types.DATE;
        if (className.equals("java.sql.Time")) return Types.TIME;
        if (className.equals("java.sql.Timestamp")) return Types.TIMESTAMP;
        if (className.equals("java.util.Date")) return Types.TIMESTAMP;

        throw new StoreException("Map Java class '" + className + "' to SQL Type Error.");
    }


    private String getDDL(Persistent obj, int type) throws StoreException {

        String tablename = getDefalutTableName(obj);
        String ddlkey = type + "ddl@" + tablename;
        com.util.CacheableString stmt;
        String[] coloum = null;

        switch (type) {
            case 1:
                if (obj.isCacheble()
                        && (stmt = (com.util.CacheableString) ddl.get(ddlkey)) != null
                        && stmt.getString() != null)
                    return stmt.getString();
                coloum = getReadWriteField(tablename);
                StringBuffer strStmt = new StringBuffer("INSERT INTO  ").append(tablename).append("( ");
                for (int i = 0; i < coloum.length; i++) {
                    if (i != 0) {
                        strStmt.append(", ");
                    }
                    strStmt.append(coloum[i].split("@")[0]);
                }
                strStmt.append(" ) VALUES ( ");
                for (int i = 0; i < coloum.length; i++) {
                    if (i != 0) {
                        strStmt.append(", ");
                    }
                    strStmt.append("?");
                }
                strStmt.append(" )");
                if (obj.isCacheble())
                    ddl.add(ddlkey, new com.util.CacheableString(strStmt.toString()));
                return strStmt.toString();


            default:
                throw new IllegalArgumentException("Illegal type specified at getDDL");
        }
    }



    protected  Persistent insertObject(Persistent obj) throws StoreException {

        this.persistent=obj;
        String tablename = getDefalutTableName(obj);
        String[] coloum = getReadWriteField(tablename);
        StringBuffer strStmt = new StringBuffer("INSERT INTO  ").append(tablename).append("( ");

        for (int i = 0; i < coloum.length; i++) {
            if (i != 0) {
                strStmt.append(", ");
            }
            strStmt.append(coloum[i].split("@")[0]);
        }

        strStmt.append(" ) VALUES ( ");
        for (int i = 0; i < coloum.length; i++) {
            if (i != 0) {
                strStmt.append(", ");
            }
            strStmt.append("?");
        }
        strStmt.append(" )");

        LoggableStatement preStmt = null;
        try {

            preStmt = new LoggableStatement(conn, strStmt.toString());
            for (int j = 0; j < coloum.length; j++) {
                String typeName = null;
                Object value = null;
                try {
                    typeName = BeanUtils.getParameterTypes(obj, coloum[j].split("@")[0]).getName();
                    value = BeanUtils.getProperty(obj, coloum[j].split("@")[0]);
                } catch (NoSuchMethodException nm) {
                    typeName = coloum[j].split("@")[1];
                    value = null;
                }

                if (value == null) {
                    preStmt.setNull(j + 1, sqlTypeFromClassName(typeName));
                } else if (typeName.equals("java.lang.String")) {
                    preStmt.setString(j + 1, (String) value);
                } else if (typeName.equals("java.sql.Date")) {
                    preStmt.setDate(j + 1, (java.sql.Date) value);
                } else if (typeName.equals("java.sql.Timestamp")) {
                    preStmt.setTimestamp(j + 1, (java.sql.Timestamp) value);
                } else if (typeName.equals("java.util.Date")) {

                    value = new java.sql.Timestamp(((java.util.Date) value).getTime());
                    preStmt.setTimestamp(j + 1, (java.sql.Timestamp) value);

                } else if (typeName.equals("java.sql.Time")) {
                    preStmt.setTime(j + 1, (java.sql.Time) value);
                } else if (typeName.equals("int")) {
                    preStmt.setInt(j + 1, ((Integer) value).intValue());
                } else if (typeName.equals("float")) {
                    preStmt.setFloat(j + 1, ((Float) value).floatValue());
                } else if (typeName.equals("long")) {
                    preStmt.setLong(j + 1, ((Long) value).longValue());
                } else if (typeName.equals("short")) {
                    preStmt.setShort(j + 1, ((Short) value).shortValue());
                } else if (typeName.equals("double")) {
                    preStmt.setDouble(j + 1, ((Double) value).doubleValue());
                } else if (typeName.equals("boolean")) {
                    preStmt.setBoolean(j + 1, ((Boolean) value).booleanValue());

                } else if (value instanceof org.apache.struts.upload.FormFile) {

                    org.apache.struts.upload.FormFile f = (org.apache.struts.upload.FormFile) value;
                    if (f.getFileSize() == 0)
                        preStmt.setNull(j + 1, sqlTypeFromClassName(typeName));
                   else {

                        preStmt.setNull(j + 1, sqlTypeFromClassName(typeName));
                    }

                }

                else {
                    preStmt.setObject(j + 1, value);
                }
            }

            if (preStmt.executeUpdate() <= 0)
                throw new StoreException("store.insertobject()  executeUpdate error ");
            else {
                obj.logger("\u589e\u52a0\u6210\u529f",preStmt.getQueryString());
               try {
                    if(isReadOnlyPKValue(obj))
                    BeanUtils.setProperty(obj, obj.getPKName(), getCurrMAXValue(obj));
                } catch (Exception e) { e.printStackTrace();  }
            }


            preStmt.close();
            if (obj.isCacheble() && getPKValue(obj) != null) {
                cach.add(getPKValue(obj) + "@" + tablename, obj);
                result.removePatter("@" + tablename);
            }

        } catch (Exception ex) {
            logger.fatal(ex.toString());
            logger.fatal(preStmt.getQueryString());

            obj = null;
            throw new StoreException(ex);

        } finally {

           //logger
            return obj;
        }
    }


    private boolean isReadOnlyPKValue(Persistent obj) {
        boolean value = false;
        try {
            if (getPKValue(obj) == null
                    || getPKValue(obj).toString().equals("")
                    || getPKValue(obj).toString().equals("0"))
            value=true;
        } catch (Exception ex) {
        }
        return value;
    }


    protected String[] getReadWriteField(String tableName) throws StoreException {
        String[] s = getFieldFromTableName(tableName);
        String s1 = "";
        for (int j = 0; j < s.length; j++) {
            String s2 = s[j];
            if (!Boolean.valueOf(s2.split("@")[2]).booleanValue()) {
                if (!s1.equals("")) s1 += "%";
                s1 += s2.substring(0, s2.lastIndexOf("@"));
            }
        }
        return s1.split("%");
    }


    protected String[] getFieldFromTableName(String tableName) throws StoreException {
        //ֶ
        boolean cacheEnabled = true;
        synchronized (tableField) {
            if (cacheEnabled && tableField.get(tableName.toLowerCase()) != null)
                return (String[]) tableField.get(tableName.toLowerCase());
        }

        Statement statement = null;
        ResultSet resultSet = null;
        ResultSetMetaData metaData = null;
        String[] field = null;
        int i = 0;
        try {

            statement = conn.createStatement();
            resultSet = statement.executeQuery("SELECT * FROM " + tableName + " WHERE 1<>1");
            if (resultSet == null) {
                throw new Exception("ResultSet : No such table:" + tableName);
            }
            metaData = resultSet.getMetaData();
            i = metaData.getColumnCount();
            field = new String[i];
            for (int j = 0; j < i; j++) {
                field[j] = metaData.getColumnLabel(j + 1) + "@" + metaData.getColumnClassName(j + 1) + "@" + metaData.isReadOnly(j + 1);
            }

            synchronized (tableField) {
                if (cacheEnabled)
                    tableField.put(tableName.toLowerCase(), field);
            }

        } catch (Exception ex) {
            throw new StoreException("No such table" + tableName);

        } finally {
            //رresultSet
            try {
                resultSet.close();
                statement.close();
                resultSet = null;
                metaData = null;
                statement = null;
            } catch (Exception re) {
                throw new StoreException(re);
            }
            return field;
        }

    }


    public Object load(Persistent p) throws StoreException {

        return load((String) getPKValue(p), p);
    }


    public Object load(String id, Persistent p) throws StoreException {

        this.persistent=p;
        Persistent p1 = null;
        String tablename = getDefalutTableName(p);
        if (id == null) id = (String) getPKValue(p);
        if (id == null) throw new StoreException("PrimaryKeyName NullValueException");
        String key = id + "@" + tablename;

        if (p.isCacheble()) {
            p1 = (Persistent) cach.get(key);
            if (p1 != null) {

                return p1;
            }
        }

        String[] coloum = getFieldFromTableName(tablename);

        HashMap typeNames = new HashMap();
        for (int j = 0; j < coloum.length; j++) {
            String typeName = null;

            try {
                typeName = BeanUtils.getParameterTypes(p, coloum[j].split("@")[0]).getName();

            } catch (NoSuchMethodException nm) {
                typeName = coloum[j].split("@")[1];

            } catch (Exception ex) {
                p = null;
                throw new StoreException(ex);
            }

            typeNames.put(coloum[j].split("@")[0], typeName);

        }
        Iterator iterator = typeNames.keySet().iterator();
        StringBuffer strStmt = new StringBuffer("SELECT ");
        while (iterator.hasNext()) {
            strStmt.append(iterator.next());
            if (iterator.hasNext()) strStmt.append(",");
        }
        strStmt.append(" FROM ").append(tablename);
        strStmt.append(" WHERE " + p.getPKName() + "=?");

        LoggableStatement preStmt = null;
        try {
            String typeName = getPKTypeName(p);
            preStmt = new LoggableStatement(conn, strStmt.toString());
            StringBuffer sb = new StringBuffer("Found no ").append(p.getPKName()).append("(type:").append(typeName).append(")=");

            if (typeName.equals("int"))
                preStmt.setInt(1, Integer.parseInt(id));
            else if (typeName.equals("long"))
                preStmt.setLong(1, Long.parseLong(id));
            else if (typeName.equals("java.lang.String"))
                preStmt.setString(1, id);
            else
                preStmt.setObject(1, id);

            java.sql.ResultSet rs = preStmt.executeQuery();
            StringBuffer tmp = null;
            if (rs.next()) {
                tmp = new StringBuffer();

                p1 = (Persistent) applicationInstance(p.getClass().getName());
                iterator = typeNames.keySet().iterator();
                for (int j = 0; iterator.hasNext(); j++) {
                    Object o = iterator.next();
                    typeName = (String) typeNames.get(o);
                    Object value = null;

                    if (j > 0) tmp.append(",");
                    tmp.append(o);

                    if (typeName.equals("java.lang.String")) {
                        value = rs.getString(j + 1);
                        if (p.isForbidNull() && value == null) value = "";

                    } else if (typeName.equals("java.sql.Date")) {
                        value = rs.getDate(j + 1);
                    } else if (typeName.equals("java.sql.Timestamp")) {
                        value = rs.getTimestamp(j + 1);
                    } else if (typeName.equals("java.util.Date")) {
                        //value = rs.getString(j + 1);
                        value = rs.getObject(j + 1);
                    } else if (typeName.equals("java.sql.Time")) {
                        value = rs.getTime(j + 1);
                    } else if (typeName.equals("int")) {
                        value = new Integer(rs.getInt(j + 1));
                    } else if (typeName.equals("float")) {
                        value = new Float(rs.getFloat(j + 1));
                    } else if (typeName.equals("long")) {
                        value = new Long(rs.getLong(j + 1));
                    } else if (typeName.equals("short")) {
                        value = new Short(rs.getShort(j + 1));
                    } else if (typeName.equals("double")) {
                        value = new Double(rs.getDouble(j + 1));
                    } else if (typeName.equals("boolean")) {
                        value = new Boolean(rs.getBoolean(j + 1));
                    } else if (typeName.equals("[B")) {
                        value = rs.getBytes(j + 1);
                    } else if (typeName.equals("org.apache.struts.upload.FormFile")) {

                        org.apache.struts.upload.DiskFile file = new org.apache.struts.upload.DiskFile();

                        file.setFileData(rs.getBytes(j + 1));

                        value = file;

                    } else {
                        value = rs.getObject(j + 1);
                    }
                    try {

                        BeanUtils.setProperty(p1, (String) o, value);
                    } catch (IllegalAccessException e) {
                        logger.error(e);
                    } catch (InvocationTargetException e) {
                        logger.error(e);
                    } catch (NoSuchMethodException e) {
                        logger.info(p.getClass().getName() + " " + e);
                    } catch (Exception e) {
                        logger.error(e);
                    } finally {

                    }
                }

            }

            rs.close();
            preStmt.close();

            if (p1 != null) {

            } else {
                logger.error(sb.append(id).append(" from ").append(tablename));
            }
        } catch (Exception e) {
            logger.fatal(e);
        } finally {

            if (p.isCacheble() && p1 != null) {

                cach.add(key, p1);
            }
            return p1;
        }
    }


    public Object load(String id, Class z) throws StoreException {
        return load(id, z.getName());
    }


    public Object load(String id, String className) throws StoreException {
        Object o = null;
        try {
            o = applicationInstance(className);
            if (o instanceof Persistent)
                return load(id, (Persistent) o);
            else
                throw new Exception("ClassCastException Persistent: " + o.getClass());
        } catch (ClassNotFoundException e) {
            throw new StoreException(e);
        } catch (IllegalAccessException e) {
            throw new StoreException(e);
        } catch (InstantiationException e) {
            throw new StoreException(e);
        } catch (Exception e) {
            throw new StoreException(e);
        }

    }


    public Object loadObject(String id) {

        try {

            if (persistent == null)
                throw new StoreException("loadobject  IllegalArgumentException");
            return load(id, persistent);
        } catch (StoreException e) {
            logger.fatal(e);
            return null;
        }
    }


    private int count = 0;
    private int pageIndex = 0;
    private int pageSize = 0;


    public int getIntPageCount() {
        if (pageSize > 0)
            return (count + pageSize - 1) / pageSize;
        else
            return 0;
    }

    public int getCount() {
        return count;
    }

    public int getIntCurPage() {
        return pageIndex;
    }


    public void setPageCtr(int pageIndex, int pageSize) {

        if (count > 0)
            logger.error("setPageCtr() method should before invoke executeQuery");
        this.pageIndex = pageIndex;
        this.pageSize = pageSize;
    }

    public java.util.Iterator executeQuery(Persistent p) throws StoreException {
        return executeQuery(p, false);
    }


    public java.util.Iterator executeQuery(Persistent p, boolean include) throws StoreException {

        if (p == null) {
            throw new StoreException("Please first init  persistent");
        }

        this.persistent = p;
        if (include) addWhere(p);
        com.framwork.page.ObjectIterator oIterator =
                new com.framwork.page.ObjectIterator(results().toArray(), this);


        if (pageSize > 0 && pageIndex > 0) {
            if (pageIndex > getIntPageCount())
                pageIndex = getIntPageCount();
            oIterator.setPageCtl(pageIndex, pageSize);
        }
        return oIterator;
    }


    public java.util.Iterator executeQuery(Class z) throws StoreException {

        try {
            return executeQuery((Persistent) applicationInstance(z.getName()));
        } catch (Exception e) {
            throw new StoreException(e);
        }

    }

    public Store addCPKey(String s) {
        this.isCPKey = true;
        addWhere(s);
        return this;
    }

    //ݸء޸ġɾbean
    public Store addWhere(String s) {
        s = filter(s).trim();
        if (!s.startsWith("AND") && !s.startsWith("OR") && where.indexOf("WHERE") != -1)
            where.append(" AND ");
        if (where.indexOf("WHERE") == -1)
            where.append(" WHERE ");
        where.append(s).append(" ");


        return this;
    }

    private StringBuffer where = new StringBuffer();
    private StringBuffer order = new StringBuffer();


    public Store addDESC(String s) {
        StringBuffer order1 = new StringBuffer();
        if (order.length() > 8) order1.append(",");
        s = order1.append(filter(s)).append(" DESC ").toString();
        addOrder(s);
        return this;

    }

    public Store addASC(String s) {
        StringBuffer order1 = new StringBuffer();
        if (order.length() > 8) order1.append(",");
        s = order1.append(filter(s)).append(" ASC ").toString();
        addOrder(s);
        return this;
    }

    public Store addOrder(String s) {
        if (order.indexOf("ORDER BY") == -1)
            order.append("ORDER BY ");

        order.append(s);
        return this;

    }

    //ȡб
    protected StringList results() {
        String tablename = getDefalutTableName(persistent);
        StringList list = null;
        StringBuffer strStmt =
                new StringBuffer("SELECT  ").append(persistent.getPKName()).append("  FROM ").append(tablename);
        String resultkey = where.toString() + "@" + tablename;
        try {
            if (where.indexOf("WHERE") != -1) strStmt.append(" ").append(where);
            if (order.indexOf("ORDER BY") != -1) strStmt.append(" ").append(order);
            if (persistent.isCacheble() && (list = (StringList) result.get(resultkey)) != null) {
                count = list.size();
                return list;
            }

            list = new StringList();

            PreparedStatement preStmt = conn.prepareStatement(strStmt.toString());
            ResultSet rs = preStmt.executeQuery();
            while (rs.next()) {
                list.add(rs.getString(1));
                count++;
            }

            rs.close();
            preStmt.close();

        } catch (Exception e) {
            logger.fatal(e.toString());
        } finally {

            if (persistent.isCacheble()) {
                result.add(resultkey, list);
            }

            return list;
        }
    }


    /**
     * bean̫ģѯ
     * @param obj
     * @throws StoreException
     */
    public void addWhere(Persistent obj) throws StoreException {
        String tablename = getDefalutTableName(obj);
        StringBuffer sb = new StringBuffer();
        String[] coloum = getFieldFromTableName(tablename);
        try {
            for (int j = 0; j < coloum.length; j++) {
                String typeName = null;
                String sqltypeName = null;
                Object value = null;
                try {

                    typeName = BeanUtils.getParameterTypes(obj, coloum[j].split("@")[0]).getName();
                    sqltypeName = coloum[j].split("@")[1];
                    value = BeanUtils.getProperty(obj, coloum[j].split("@")[0]);

                } catch (NoSuchMethodException nm) {
                    continue;
                }

                //ADD opt
                if (sb.length() > 3 && !sb.toString().trim().endsWith("AND"))
                    sb.append(" AND ");

                if (value != null && !value.toString().equals("0")
                        && !typeName.equals("[B")
                        && !(value instanceof org.apache.struts.upload.FormFile)) {
                    if (typeName.equals("int")) {
                        sb.append(coloum[j].split("@")[0]).append("=").append(((Integer) value).intValue());
                    } else if (typeName.equals("float")) {
                        sb.append(coloum[j].split("@")[0]).append("=").append(((Float) value).floatValue());
                    } else if (typeName.equals("long")) {
                        sb.append(coloum[j].split("@")[0]).append("=").append(((Long) value).longValue());
                    } else if (typeName.equals("short")) {
                        sb.append(coloum[j].split("@")[0]).append("=").append(((Short) value).shortValue());
                    } else if (typeName.equals("double")) {
                        sb.append(coloum[j].split("@")[0]).append("=").append(((Double) value).doubleValue());
                    } else if (sqltypeName.equals("java.sql.Timestamp") ||
                            sqltypeName.equals("java.sql.Time") ||
                            sqltypeName.equals("java.util.Time") ||
                            sqltypeName.equals("java.sql.Date")) {

                        String[] t = ((String) value).split("%");

                        if (t.length > 0 && t[0] != null && !t[0].equals("")) {


                                sb.append("to_date('").append(com.framwork.util.DateUtil.formatDate(t[0], "yyyy-MM-dd HH:mm:ss"))
                                        .append("','yyyy-mm-dd hh24:mi:ss')-")
                                        .append(coloum[j].split("@")[0])
                                        .append("<=1");
                        }

                        if (t.length == 2 && t[1] != null && !t[1].equals("")) {
                            if (t[0] != null && !t[0].equals("")) sb.append(" AND ");
                            {

                                    sb.append("to_date('").append(com.framwork.util.DateUtil.formatDate(t[0], "yyyy-MM-dd HH:mm:ss"))
                                            .append("','yyyy-mm-dd hh24:mi:ss')-")
                                            .append(coloum[j].split("@")[0])
                                            .append(">=1");
                            }
                        }

                    } else {

                        sb.append(coloum[j].split("@")[0]).append(" LIKE '%").append(value).append("%'");
                    }
                }
            }

        } catch (Exception e) {
            e.printStackTrace();
            logger.fatal(e.getStackTrace());
        } finally {

            if (!sb.equals("")) {

                while (sb.toString().trim().endsWith("AND")) {
                    sb.delete(sb.lastIndexOf("AND"), sb.lastIndexOf("AND") + 3);
                }
                if (where.indexOf("WHERE") == -1)
                    where.append(" WHERE ").append(sb);
                else if (!sb.toString().trim().equals("")) {
                    where.append(" AND ").append(sb);
                }
            }
        }
    }


    /**
     * Proxy CmpFileInputAndFileName setFilter(boolean b);
     * data files.
     * Author:BILL 2004-09-19
     */
    private boolean isFilter = false;

    public void setFilter(boolean b) {
        isFilter = b;
    }

    public void clearParameters() {
        this.count = 0;
        this.pageIndex = 0;
        this.pageSize = 0;
        this.where = new StringBuffer();
        this.order = new StringBuffer();
        this.isCPKey = false;


    }
    private boolean isCPKey = false;
    private java.util.ArrayList logger0 = new java.util.ArrayList();
    public java.util.List getSQLLogger() {

       return logger0;
    }


}
