package com.framwork.filter;

import java.io.IOException;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;


/**
 * @ web.filter  	name = "CharEncoding"
 * @ web.filter-init-param  	name = "encoding"  	value = "GB2312"
 * @ web.filter-mapping    servlet-name = "action"
 */

public class EncodingFilter implements Filter {

    private static Log log = LogFactory.getLog(Filter.class);

    protected String encoding = null;
    protected FilterConfig filterConfig = null;

    public void destroy() {
        this.encoding = null;
        this.filterConfig = null;
    }

    public void doFilter(ServletRequest request, ServletResponse response,
                         FilterChain chain)
            throws IOException, ServletException {

        String encoding = selectEncoding();
        if (encoding != null)
            request.setCharacterEncoding(encoding);

        chain.doFilter(request, response);
    }

    public void init(FilterConfig filterConfig) throws ServletException {

        this.filterConfig = filterConfig;
        this.encoding = filterConfig.getInitParameter("encoding");
        log.debug("EncodingFilter  init "+encoding);
    }

    protected String selectEncoding() {
        return (this.encoding);
    }


}

