package com.framwork.page;

import java.util.*;
import java.io.Serializable;

public class PageIterator implements Iterator, Serializable {

  public final static Object[] EMPTY = new Object[0];

  private int allCount = 0;
  //һҳеԪ
  private Object[] keys;
  private int currentIndex = -1;
  private Object nextElement = null;
  //ϲǶkeysԪʵֱ

  int start;
  boolean hasNext;
  //йҳΪλϢ

  /**
   *
   * allCount PageIteratorҪ
   * Ϊ丳ֵȽϺ󣬹ʹ캯δ롣
   *
   * @param keys Object[]
   * @param start int
   * @param hasNext boolean
   */
  public PageIterator(int allCount, Object[] keys, int start, boolean hasNext) {
    this.allCount = allCount;
    this.keys = keys;
    this.start = start;
    this.hasNext = hasNext;
  }

  public PageIterator(Object[] keys, int start, boolean hasNext) {
    this.allCount = 0;
    this.keys = keys;
    this.start = start;
    this.hasNext = hasNext;
  }


  public PageIterator() {
      this.allCount = 0;
      this.keys = EMPTY;
      this.start = 0;
      this.hasNext = false;
    }


  /**
   *  Ϊָ룬ûʱͻ
   * @return Object
   */
  public Object clone() {
     PageIterator pi = new PageIterator(0, this.keys, this.start, this.hasNext);
     pi.setAllCount(this.allCount);
     return pi;
   }


  public int getAllCount() {
    return allCount;
  }

  public void setAllCount(int allCount) {
    this.allCount = allCount;
  }

  //λ Աٴʹ
  public void reset() {
    currentIndex = -1;
    nextElement = null;

  }

  /**
   * Returns true if there are more elements in the iteration.
   * @return true if the iterator has more elements.
   */
  public boolean hasNext() {
    // If we are at the end of the list, there can't be any more elements
    // to iterate through.
    if (currentIndex + 1 >= keys.length && nextElement == null) {
      return false;
    }
    // Otherwise, see if nextElement is null. If so, try to load the next
    // element to make sure it exists.
    if (nextElement == null) {
      nextElement = getNextElement();
      if (nextElement == null) {
        return false;
      }
    }
    return true;
  }

  /**
   * Returns the next element.
   *
   * @return the next element.
   * @throws NoSuchElementException if there are no more elements.
   */
  public Object next() throws java.util.NoSuchElementException {
    Object element = null;
    if (nextElement != null) {
      element = nextElement;
      nextElement = null;
    } else {
      element = getNextElement();
      if (element == null) {
        throw new java.util.NoSuchElementException();
      }
    }
    return element;
  }

  /**
   * Not supported for security reasons.
   */
  public void remove() throws UnsupportedOperationException {
    throw new UnsupportedOperationException();
  }

  /**
   * Returns the next available element, or null if there are no more
   * elements to return.
   *
   * @return the next available element.
   */
  public Object getNextElement() {
    while (currentIndex + 1 < keys.length) {
      currentIndex++;
      Object element = keys[currentIndex];
      if (element != null) {
        return element;
      }
    }
    return null;
  }

  public boolean isNextPageAvailable() {
    return hasNext;
  }

  public boolean isPreviousPageAvailable() {
    return start > 0;
  }

  public int getStartOfNextPage() {
    return start + keys.length;
  }

  public int getStartOfPreviousPage() {
    return Math.max(start - keys.length, 0);
  }

  public int getSize() {
    return keys.length;
  }


}
