package com.framwork.util;

import org.apache.commons.logging.LogFactory;
import org.apache.commons.logging.Log;

import java.sql.*;
import java.text.SimpleDateFormat;


public final class SequenceManager {

    private static Log log = LogFactory.getLog(SequenceManager.class);

    public static final String PATTERN_YEAR = "yyyy";
    public static final String PATTERN_MONTH = "yyyyMM";
    public static final String PATTERN_DATE = "yyyyMMdd";
    private static final int iSign = 1000000001; //10λ;


    public static String generateID(Connection conn, String table, String field, String pattern, int len) {
        SequenceManager sm = new SequenceManager();
        String sid = null;
        String sPattern = sm.getStringDate(pattern);
        StringBuffer sSql = new StringBuffer();
        sSql.append(" SELECT max(").append(field).append(") FROM  ").append(table)
                .append(" WHERE\n (").append(field).append(" > ? AND ").append(field).append(" <  ? )");
        try {
            PreparedStatement ps = conn.prepareStatement(sSql.toString());
            ps.setString(1, sPattern + sm.formatSameString("0", len));
            ps.setString(2, sPattern + sm.formatSameString("9", len));

            ResultSet rs = ps.executeQuery();
            if (rs.next()) sid = rs.getString(1);
            rs.close();
            return sm.createTimeID(pattern, sid, len);

        } catch (SQLException e) {
            e.printStackTrace();
            log.error("ʱʧ: \n" + sSql.toString() + "\n" + sPattern + sm.formatSameString("0", len));
            return null;
        }
    }

    public static String generateID(Connection conn, String table, String field) {
        return generateID(conn, table, field, PATTERN_DATE, 4);
    }

    /**
     * ʱIDʹֵ+1
     *
     * @param pattern
     * @param sDefault   ʼֵ
     * @param iFreeDigit λ<=10
     * @return ַ
     */
    private String createTimeID(String pattern, String sDefault, int iFreeDigit) {
        if (sDefault == null || sDefault.trim().equals("")) {
            return getStringDate(pattern) + amendDigit(iFreeDigit, 0); //ʼֵ
        }

        String strFree = sDefault.substring(pattern.length());//ȡִ

        return getStringDate(pattern) + amendDigit(iFreeDigit, strFree);
    }


    /**
     * ȡǰ
     *
     * @return
     */
    private String getStringDate(String pattern) {
        if (!pattern.equals(PATTERN_DATE) && !pattern.equals(PATTERN_YEAR) && !pattern.equals(PATTERN_MONTH))
            pattern = PATTERN_DATE;

        SimpleDateFormat sf = new SimpleDateFormat(pattern);
        return sf.format(new java.util.Date());
    }

    /**
     * λʹֵ+1
     *
     * @param iFreeDigit λ<=10
     * @param iDefault   ʼֵ
     * @return ַ
     */
    private String amendDigit(int iFreeDigit, int iDefault) {
        int iTemp = 0;
        if (iFreeDigit < 10) {
            iTemp = iSign;
        } else {
            //̫
        }
        iFreeDigit += 1;
        iTemp += iDefault;
        String strTemp = new Integer(iTemp).toString();
        strTemp = strTemp.substring(11 - iFreeDigit, 10);
        //System.out.println("---strTemp-amendDigit -"+strTemp);
        return strTemp;
    }

    /**
     * λ
     *
     * @param iFreeDigit λ<=10
     * @param strDefFree ʼ
     * @return ַ
     */
    private String amendDigit(int iFreeDigit, String strDefFree) {

        return amendDigit(iFreeDigit, Integer.parseInt(strDefFree));

    }

    /**
     * ظַַ
     *
     * @param s   "*"
     * @param len 4
     * @return "****"
     */
    private String formatSameString(String s, int len) {
        if (len == 0 || null == s) return "";
        StringBuffer bf = new StringBuffer();
        for (int i = 0; i < len; i++) {
            bf.append(s);
        }
        return bf.toString();
    }

    public static void main(String[] args) {
        String sqlDriver = "com.microsoft.jdbc.sqlserver.SQLServerDriver";
        String sqlURL = "jdbc:microsoft:sqlserver://192.168.1.1:1433";
        String sqlUsr = "hefei_Stip";
        String sqlPwd = "hefei_Stip_pass";
        try {
            Class.forName(sqlDriver);
            Connection conn = DriverManager.getConnection(sqlURL, sqlUsr, sqlPwd);
            Statement stmt = conn.createStatement();
            ResultSet rs = stmt.executeQuery("select * from t_column");
            while (rs.next()) {
                System.out.println(rs.getString("textRemark"));
            }
            conn.close();
        } catch (Exception e) {
            e.printStackTrace();
            //log.fatal("ʧ\n" + e.toString());
        }
    }


}
