package com.framwork.web;

import com.framwork.util.Debug;
import com.framwork.model.TargetMetaDef;
import com.framwork.model.ComponentCacheVisitor;
import com.framwork.model.Visitable;

import javax.servlet.http.HttpSessionBindingListener;
import javax.servlet.http.HttpSessionBindingEvent;
import java.util.Map;
import java.util.HashMap;
import java.util.Iterator;


/**
 * ṩHttSessionķʣЩΪ˼ܡ
 *
 HttpSessionBindingListener
    ÿSessionдһsetAttributeSessionɾһʱ
   ԶɾSessionʱ
    ʵ˴˼ӿڣӦ÷ԶýӿӦķ
    valueBoundvalueUnbound
 HttpSessionBindingListenerHttpSessionListener
 ǰweb.xml
 *
 * <p>Copyright: Jdon.com Copyright (c) 2005</p>
 * <p></p>
 * @author banq
 * @version JdonSD 2.5
 */
public class HttpSessionProxyVisitor implements ComponentCacheVisitor, HttpSessionBindingListener{

    private final static String module = HttpSessionProxyVisitor.class.getName();

  private Map componentsboxs = new HashMap();

  private VisitableFactory visitableFactory;

    public HttpSessionProxyVisitor(VisitableFactory visitableFactory){
      this.visitableFactory = visitableFactory;
  }

  public void valueBound(HttpSessionBindingEvent event) {
    Debug.logVerbose(" valueBound active, sessionId :" + event.getSession().getId() , module);
    Debug.logVerbose(" valueBound active, componentsboxs size:" + componentsboxs.size() , module);
  }

  /**
   * session destroyed.
   * ȥ״̬Session Bean֮״̬á
   */
  public void valueUnbound(HttpSessionBindingEvent event) {
     String sessionId = event.getSession().getId();
     Debug.logVerbose(" unvalueBound active, sessionId :" + sessionId , module);
     Debug.logVerbose(" unvalueUnbound active, componentsboxs size" + componentsboxs.size(), module);
     removeObjects();
  }

  public Object visit(TargetMetaDef targetMetaDef){
    StringBuffer sb = new StringBuffer(targetMetaDef.getCacheKey());
    sb.append(targetMetaDef.getVisitableName());
    Debug.logVerbose(" visit key is " + sb.toString(), module);
    Object o = componentsboxs.get(sb.toString());
    if (o == null){
      Visitable vo = visitableFactory.createVisitable(targetMetaDef);
      o = vo.accept(this);
      componentsboxs.put(sb.toString(), o);
    }else{
      Debug.logVerbose(" got the component from session ", module);
    }
    return o;
  }


  /**
   * ҪһЩȥ
   */
  public  void removeObjects(){
     try {
       Iterator iter = componentsboxs.keySet().iterator();
       while (iter.hasNext()) {
         String key = (String) iter.next();
         Object ccEjb = (Object) componentsboxs.get(key);
         removeEJBObject(key);
       }
     } catch (Exception ex) {
       Debug.logWarning(ex, module);
     } finally {
       componentsboxs.clear();
     }
    }

    /**
     * destroy the EJB.
     */
    private void removeEJBObject(Object ccEjb) {

    }



}
