package com.framwork.web;


import com.framwork.aop.AopClient;
import com.framwork.model.TargetMetaDef;
import com.framwork.model.TargetService;
import com.framwork.model.Visitable;


public class VisitableFactory {


  private AopClient aopClient;
  private TargetService targetService;

  public VisitableFactory(AopClient aopClient, TargetService targetService) {
    this.aopClient = aopClient;
    this.targetService = targetService;
  }

  public Visitable createVisitable(TargetMetaDef targetMetaDef) {

    if (targetMetaDef.getVisitableName().equals(VisitableNames.PROXYINSTANCE_NAME))

      return new ProxyInstanceVisitable(targetMetaDef, aopClient);
    /*
    else if (targetMetaDef.getVisitableName().equals(VisitableNames.EJBTARGETSERVICE_NAME))
      return new EJBTargetServiceVisitable(targetMetaDef,  targetService);
      */
    else
      return null;
  }

}
