package com.framwork.web;

import com.framwork.util.Debug;
import com.framwork.aop.AopClient;
import com.framwork.model.TargetMetaDef;
import com.framwork.model.MyComponentProps;
import com.framwork.model.ComponentCacheVisitor;
import com.framwork.model.MethodMetaArgs;

import java.lang.reflect.InvocationHandler;
import java.lang.reflect.Method;

/**
 * ̬
 *
 * ʵAOP
 *
 * <p>Copyright: Jdon.com Copyright (c) 2003</p>
 * <p></p>
 * @author banq
 * @version 1.0
 */

public class WebInvocationHandler implements InvocationHandler, MyComponentProps, java.io.Serializable {


    private final static String module = WebInvocationHandler.class.getName();

    private AopClient aopClient;
    private TargetMetaDef targetMetaDef;
    private ComponentCacheVisitor cm;

    public WebInvocationHandler(TargetMetaDef targetMetaDef, AopClient aopClient) {
        this.targetMetaDef = targetMetaDef;
        this.aopClient = aopClient;
    }

    public void setVisitor(ComponentCacheVisitor cm) {
        this.cm = cm;
    }

    /**
     * 
     * Ҫطʵ֡
     * @param p_proxy Object
     * @param m Method
     * @param args Object[]
     * @throws Throwable
     * @return Object
     */
    public Object invoke(Object p_proxy, Method m, Object[] args)
            throws Throwable {

        Debug.logVerbose("call method:" + m.getName(), module);
        Object result = null;

        try {

            MethodMetaArgs methodMetaDef = new MethodMetaArgs(m, args);
            targetMetaDef.setMethodMetaArgs(methodMetaDef);
            result = aopClient.invoke(cm, targetMetaDef);

        } catch (Exception ex) {
            Debug.logError(ex, module);
        } catch (Throwable ex) {
            throw new Throwable(ex);
        }

        return result;

    }

}
