package com.util;

import java.io.*;

/**
 * ַ<br>
 * @author BILL
 * @version $Revision: 1.0 $ $Date: 2004-8-11 12:48:29 $
 */

public class StringUtil {
    /**
     * iso-8859-1ַ
     */
    public static final String ISO_8859_1 = "iso-8859-1";
    /**
     * GBKַ
     */
    public static final String GBK = "GBK";
    /**
     * GB2312ַ
     */
    public static final String GB2312 = "gb2312";

    /**
     * ַת
     * @param s Ҫתַ
     * @param charSetName ַ
     * @param defaultCharSetName Ĭַ
     * @return String תַ
     */
    public static String CharSetConvert(String s, String charSetName, String defaultCharSetName) {
        String newString = null;
        try {
            newString = new String(s.getBytes(charSetName), defaultCharSetName);
        } catch (UnsupportedEncodingException e) {

            System.out.println("StringUtil.CharSetConvert() UnsupportedEncodingException" + e);

        } catch (NullPointerException nulle) {
            System.out.println("StringUtil.CharSetConvert() NullPointerException" + nulle);

        }
        return newString;
    }


    public static String CharSetConvertDefault(String s) {

        return CharSetConvert(s, ISO_8859_1, GBK);

    }


    private static int by2int(int b) {
        return b & 0xff;
    }

    public static String Utf2String(byte buf[]) {
        int len = buf.length;
        StringBuffer sb = new StringBuffer(len / 2);
        for (int i = 0; i < len; i++) {

            if (by2int(buf[i]) <= 0x7F)
                sb.append((char) buf[i]);
            else if (by2int(buf[i]) <= 0xDF && by2int(buf[i]) >= 0xC0) {
                int bh = by2int(buf[i] & 0x1F);
                int bl = by2int(buf[++i] & 0x3F);

                bl = by2int(bh << 6 | bl);
                bh = by2int(bh >> 2);
                int c = bh << 8 | bl;
                sb.append((char) c);
            } else if (by2int(buf[i]) <= 0xEF && by2int(buf[i]) >= 0xE0) {
                int bh = by2int(buf[i] & 0x0F);
                int bl = by2int(buf[++i] & 0x3F);
                int bll = by2int(buf[++i] & 0x3F);

                bh = by2int(bh << 4 | bl >> 2);
                bl = by2int(bl << 6 | bll);


                int c = bh << 8 | bl;
                //ոתΪ
                if (c == 58865) {
                    c = 32;
                }
                sb.append((char) c);

            }
        }
        return sb.toString();

    }



/////////////////////////////////////////////////////
    public void testCharSetConvert() {
        StringUtil test = new StringUtil();
        test.CharSetConvert("dsasafda", ISO_8859_1, GBK);
    }


    public static String ConvertSizeToStr(long l) {
        java.text.DecimalFormat df = new java.text.DecimalFormat("0.00");
        if (l < 1024L)
            return l + "bytes";
        else if (l / 1024F < 1024F)
            return df.format(l / 1024F) + "K";

        else if (l / 1024F / 1024 < 1024F)
            return df.format(l / 1024F / 1024) + "M";
        else
        // if (l / 1024F / 1024 / 1024 < 1024F)
            return df.format(l / 1024F / 1024 / 1024) + "G";

    }


    public static String getDecimalFormat(float f) {
        java.text.DecimalFormat df = new java.text.DecimalFormat("0.00");
        return df.format(f);
    }

    public static String getISOTOGBK(String s) {
        return CharSetConvert(s, ISO_8859_1, GBK);
    }

    public static String getGBKTOISO(String s) {
        return CharSetConvert(s, GBK, ISO_8859_1);
    }

    /**
     * ַתUnicode
     * @param strText תַ
     * @param code תǰַı룬"GBK"
     * @return תUnicodeַ
     */
    public static String toUnicode(String strText, String code) throws UnsupportedEncodingException {
        char c;
        String strRet = "";
        int intAsc;
        String strHex;
        strText = new String(strText.getBytes("8859_1"), code);
        for (int i = 0; i < strText.length(); i++) {
            c = strText.charAt(i);
            intAsc = (int) c;
            if (intAsc > 128) {
                strHex = Integer.toHexString(intAsc);
                strRet = strRet + "&#x" + strHex + ";";
            } else {
                strRet = strRet + c;
            }
        }
        return strRet;
    }


    public static void main(String[] args) throws Exception {

      
    }


}
